
-------------------------------------------------------------------------------
--! @file       Block_Counter.vhd
--! @author     William Diehl
--! @brief      POET Block_Counter
--! @date       10 July 2016
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY Block_Counter IS
	GENERIC( G_MAX_LEN: integer:= 28);
	PORT(
	 CLK: IN STD_LOGIC;
	 EN: IN STD_LOGIC;
	 INIT: IN STD_LOGIC;
	 C_IN: IN STD_LOGIC_VECTOR(G_MAX_LEN - 1 DOWNTO 0); 
	 C_OUT: OUT STD_LOGIC_VECTOR(G_MAX_LEN - 1 DOWNTO 0) 
	 );

END Block_Counter;


ARCHITECTURE behavioral OF Block_Counter IS

BEGIN
   counter: PROCESS(CLK)

-- INIT is synchronous Reset; preempts enable
-- EN is enable

   BEGIN
   		
	IF (rising_edge(CLK)) THEN
		IF (INIT = '1') 
		  THEN C_OUT <= (OTHERS=> '0');
		ELSIF (EN = '1') 
                    THEN C_OUT <= C_IN;
                  
                    
      END IF;	
	END IF;	
  	
   END PROCESS;
	 
END behavioral; 	

