
-------------------------------------------------------------------------------
--! @file       GF128_mul_2.vhd
--! @author     William Diehl
--! @brief      POET GF128_mul_2
--! @date       10 July 2016
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;


entity GF128_mul_2 is
    Port ( input : in  STD_LOGIC_VECTOR (127 downto 0);
           result : out  STD_LOGIC_VECTOR (127 downto 0));
end GF128_mul_2;

architecture dataflow of GF128_mul_2 is

signal a : std_logic_vector(127 downto 0);

begin

  -- GCM polynomial a^128 + a^7 + a^2 + a + 1
  -- POET uses little endian for GF128 multiplication
  -- bit order 0, 1, 2, ... 127
  
   a<= input(0) & input(0) & input(0) & x"0" & input(0) & x"000000000000000000000000000000";
   result <= '0' & input(127 downto 1) XOR a;

end dataflow;

