

-------------------------------------------------------------------------------
--! @file       Register.vhd
--! @author     William Diehl
--! @brief      POET Register
--! @date       10 July 2016
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity register_generic is
	generic( 
		width: integer :=128);
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           en : in  STD_LOGIC;
           data : in  STD_LOGIC_VECTOR (width-1 downto 0);
           q : out  STD_LOGIC_VECTOR (width-1 downto 0));
end register_generic;

architecture Behavioral of register_generic is

begin
	process (rst, clk)
	begin
	if (rst='1') then
		q <= (others => '0');
	elsif (rising_edge(clk)) then
	if (en='1') then
		q <= data;
	end if;
end if;
end process;
end Behavioral;
		

