
-------------------------------------------------------------------------------
--! @file       to_little_endian.vhd
--! @author     William Diehl
--! @brief      POET to_little_endian
--! @date       10 July 2016
-------------------------------------------------------------------------------

-- Convert to little enddian
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY to_little_endian IS

	PORT(
		input: IN STD_LOGIC_VECTOR(127 DOWNTO 0);
		result: OUT STD_LOGIC_VECTOR(127 DOWNTO 0)
	);

END to_little_endian;

ARCHITECTURE dataflow OF to_little_endian IS

BEGIN

	result(127 downto 120) <= input(7 downto 0);
	result(119 downto 112) <= input(15 downto 8);
	result(111 downto 104) <= input(23 downto 16);
	result(103 downto 96) <= input(31 downto 24);
	result(95 downto 88) <= input(39 downto 32);
	result(87 downto 80) <= input(47 downto 40);
	result(79 downto 72) <= input(55 downto 48);
	result(71 downto 64) <= input(63 downto 56);
	result(63 downto 56) <= input(71 downto 64);
	result(55 downto 48) <= input(79 downto 72);
	result(47 downto 40) <= input(87 downto 80);
	result(39 downto 32) <= input(95 downto 88);
	result(31 downto 24) <= input(103 downto 96);
	result(23 downto 16) <= input(111 downto 104);
	result(15 downto 8) <= input(119 downto 112);
	result(7 downto 0) <= input(127 downto 120);
	

END dataflow;