

-------------------------------------------------------------------------------
--! @file       variable_left_shift.vhd
--! @author     William Diehl
--! @brief      POET variable_left_shift
--! @date       10 July 2016
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;


entity variable_left_shift is
    Port ( input : in  STD_LOGIC_VECTOR (127 downto 0);
           distance : in  STD_LOGIC_VECTOR (3 downto 0);
           result : out  STD_LOGIC_VECTOR (127 downto 0));
end variable_left_shift;

architecture structural of variable_left_shift is

signal x1a, x1b, x2a, x2b, x3a, x3b, x4a, x4b : std_logic_vector(127 downto 0);

begin

x1a <= input;

x1b <= input(119 downto 0)& x"00";

x2a <= x1a when (distance(0)='0') else x1b; -- variable shift left one byte

x2b <= x2a(111 downto 0)& x"0000";

x3a <= x2a when (distance(1)='0') else x2b; -- variable shift left two bytes

x3b <= x3a(95 downto 0) & x"00000000";

x4a <= x3a when (distance(2)='0') else x3b; -- variable shift left four bytes

x4b <= x4a(63 downto 0) & x"0000000000000000";

result <= x4a when (distance(3)='0') else x4b; -- variable shift left eight bytes

end structural;




